addHook("PlayerThink", function(p)
	if p.mo and p.mo.skin == "king" then
		if p.skincolor == SKINCOLOR_FAKER then
			p.charability = CA_DOUBLEJUMP
			p.charflags = SF_NOJUMPSPIN|SF_SUPER|SF_DASHMODE|SF_RUNONWATER|SF_FASTEDGE|SF_STOMPDAMAGE|SF_CANBUSTWALLS|SF_NONIGHTSSUPER
			if p.mo.eflags & MFE_UNDERWATER then
				p.charflags = $ | SF_MULTIABILITY
			end
			if not p.skincolor == SKINCOLOR_FAKER then return end
		end
		if p.skincolor == SKINCOLOR_FREEZY then
			p.charability = CA_FLOAT
			p.charflags = SF_MULTIABILITY|SF_SUPER|SF_DASHMODE|SF_RUNONWATER|SF_FASTEDGE|SF_STOMPDAMAGE|SF_NONIGHTSSUPER
			p.charflags = $ & ~SF_NOSHIELDABILITY
			if p.pflags & PF_THOKKED and not (p.pflags & PF_SHIELDABILITY) then
				if p.mo.state == S_PLAY_FLOAT or p.mo.state == S_PLAY_FLOAT_RUN or p.mo.state == S_PLAY_FALL then
					p.mo.state = S_FREZ_ICE
				end
				if (p.mo.state == S_FREZ_ICE) and (p.cmd.buttons & BT_USE) then
					p.pflags = $ & ~PF_THOKKED
					p.pflags = $ | PF_SHIELDABILITY
					P_DoJumpShield(p)
				end
			end
			if not p.skincolor == SKINCOLOR_FREEZY then return end
		end
		if p.skincolor == SKINCOLOR_BILLY then
			p.charability = CA_HOMINGTHOK
			p.actionspd = 127*FRACUNIT/1
			p.charflags = SF_SUPER|SF_DASHMODE|SF_RUNONWATER|SF_FASTEDGE|SF_STOMPDAMAGE|SF_MACHINE|SF_NONIGHTSSUPER
			p.charflags = $ & ~SF_NOSHIELDABILITY
			if not p.skincolor == SKINCOLOR_BILLY then return end
		end
		if p.skincolor == SKINCOLOR_FUNKY then
			p.charability = CA_FLY
			p.actionspd = 100*FRACUNIT
			p.charflags = SF_MULTIABILITY|SF_SUPER|SF_DASHMODE|SF_NOSHIELDABILITY|SF_RUNONWATER|SF_FASTEDGE|SF_STOMPDAMAGE|SF_NONIGHTSSUPER
			p.charflags = $ & ~SF_NOSHIELDABILITY
			if not p.skincolor == SKINCOLOR_FUNKY then return end
		end
	end
end)